Index: issm/trunk/externalpackages/export_fig/ghostscript.m
===================================================================
--- issm/trunk/externalpackages/export_fig/ghostscript.m	(revision 19105)
+++ issm/trunk/externalpackages/export_fig/ghostscript.m	(revision 21341)
@@ -1,2 +1,3 @@
+function varargout = ghostscript(cmd)
 %GHOSTSCRIPT  Calls a local GhostScript executable with the input command
 %
@@ -20,139 +21,176 @@
 %   result - Output from ghostscript.
 
-% Copyright: Oliver Woodford, 2009-2013
+% Copyright: Oliver Woodford, 2009-2015, Yair Altman 2015-
+%{
+% Thanks to Jonas Dorn for the fix for the title of the uigetdir window on Mac OS.
+% Thanks to Nathan Childress for the fix to default location on 64-bit Windows systems.
+% 27/04/11 - Find 64-bit Ghostscript on Windows. Thanks to Paul Durack and
+%            Shaun Kline for pointing out the issue
+% 04/05/11 - Thanks to David Chorlian for pointing out an alternative
+%            location for gs on linux.
+% 12/12/12 - Add extra executable name on Windows. Thanks to Ratish
+%            Punnoose for highlighting the issue.
+% 28/06/13 - Fix error using GS 9.07 in Linux. Many thanks to Jannick
+%            Steinbring for proposing the fix.
+% 24/10/13 - Fix error using GS 9.07 in Linux. Many thanks to Johannes 
+%            for the fix.
+% 23/01/14 - Add full path to ghostscript.txt in warning. Thanks to Koen
+%            Vermeer for raising the issue.
+% 27/02/15 - If Ghostscript croaks, display suggested workarounds
+% 30/03/15 - Improved performance by caching status of GS path check, if ok
+% 14/05/15 - Clarified warning message in case GS path could not be saved
+% 29/05/15 - Avoid cryptic error in case the ghostscipt path cannot be saved (issue #74)
+% 10/11/15 - Custom GS installation webpage for MacOS. Thanks to Andy Hueni via FEX
+%}
 
-% Thanks to Jonas Dorn for the fix for the title of the uigetdir window on
-% Mac OS.
-% Thanks to Nathan Childress for the fix to the default location on 64-bit
-% Windows systems.
-% 27/4/11 - Find 64-bit Ghostscript on Windows. Thanks to Paul Durack and
-% Shaun Kline for pointing out the issue
-% 4/5/11 - Thanks to David Chorlian for pointing out an alternative
-% location for gs on linux.
-% 12/12/12 - Add extra executable name on Windows. Thanks to Ratish
-% Punnoose for highlighting the issue.
-% 28/6/13 - Fix error using GS 9.07 in Linux. Many thanks to Jannick
-% Steinbring for proposing the fix.
-% 24/10/13 - Fix error using GS 9.07 in Linux. Many thanks to Johannes
-% for the fix.
-% 23/01/2014 - Add full path to ghostscript.txt in warning. Thanks to Koen
-% Vermeer for raising the issue.
-
-function varargout = ghostscript(cmd)
-% Initialize any required system calls before calling ghostscript
-shell_cmd = '';
-if isunix
-    shell_cmd = 'export LD_LIBRARY_PATH=""; '; % Avoids an error on Linux with GS 9.07
-end
-if ismac
-    shell_cmd = 'export DYLD_LIBRARY_PATH=""; ';  % Avoids an error on Mac with GS 9.07
-end
-% Call ghostscript
-[varargout{1:nargout}] = system(sprintf('%s"%s" %s', shell_cmd, gs_path, cmd));
+    try
+        % Call ghostscript
+        [varargout{1:nargout}] = system([gs_command(gs_path()) cmd]);
+    catch err
+        % Display possible workarounds for Ghostscript croaks
+        url1 = 'https://github.com/altmany/export_fig/issues/12#issuecomment-61467998';  % issue #12
+        url2 = 'https://github.com/altmany/export_fig/issues/20#issuecomment-63826270';  % issue #20
+        hg2_str = ''; if using_hg2, hg2_str = ' or Matlab R2014a'; end
+        fprintf(2, 'Ghostscript error. Rolling back to GS 9.10%s may possibly solve this:\n * <a href="%s">%s</a> ',hg2_str,url1,url1);
+        if using_hg2
+            fprintf(2, '(GS 9.10)\n * <a href="%s">%s</a> (R2014a)',url2,url2);
+        end
+        fprintf('\n\n');
+        if ismac || isunix
+            url3 = 'https://github.com/altmany/export_fig/issues/27';  % issue #27
+            fprintf(2, 'Alternatively, this may possibly be due to a font path issue:\n * <a href="%s">%s</a>\n\n',url3,url3);
+            % issue #20
+            fpath = which(mfilename);
+            if isempty(fpath), fpath = [mfilename('fullpath') '.m']; end
+            fprintf(2, 'Alternatively, if you are using csh, modify shell_cmd from "export..." to "setenv ..."\nat the bottom of <a href="matlab:opentoline(''%s'',174)">%s</a>\n\n',fpath,fpath);
+        end
+        rethrow(err);
+    end
 end
 
 function path_ = gs_path
-% Return a valid path
-% Start with the currently set path
-path_ = user_string('ghostscript');
-% Check the path works
-if check_gs_path(path_)
-    return
-end
-% Check whether the binary is on the path
-if ispc
-    bin = {'gswin32c.exe', 'gswin64c.exe', 'gs'};
-else
-    bin = {'gs'};
-end
-for a = 1:numel(bin)
-    path_ = bin{a};
-    if check_store_gs_path(path_)
+    % Return a valid path
+    % Start with the currently set path
+    path_ = user_string('ghostscript');
+    % Check the path works
+    if check_gs_path(path_)
         return
     end
-end
-% Search the obvious places
-if ispc
-    default_location = 'C:\Program Files\gs\';
-    dir_list = dir(default_location);
-    if isempty(dir_list)
-        default_location = 'C:\Program Files (x86)\gs\'; % Possible location on 64-bit systems 
+    % Check whether the binary is on the path
+    if ispc
+        bin = {'gswin32c.exe', 'gswin64c.exe', 'gs'};
+    else
+        bin = {'gs'};
+    end
+    for a = 1:numel(bin)
+        path_ = bin{a};
+        if check_store_gs_path(path_)
+            return
+        end
+    end
+    % Search the obvious places
+    if ispc
+        default_location = 'C:\Program Files\gs\';
         dir_list = dir(default_location);
+        if isempty(dir_list)
+            default_location = 'C:\Program Files (x86)\gs\'; % Possible location on 64-bit systems
+            dir_list = dir(default_location);
+        end
+        executable = {'\bin\gswin32c.exe', '\bin\gswin64c.exe'};
+        ver_num = 0;
+        % If there are multiple versions, use the newest
+        for a = 1:numel(dir_list)
+            ver_num2 = sscanf(dir_list(a).name, 'gs%g');
+            if ~isempty(ver_num2) && ver_num2 > ver_num
+                for b = 1:numel(executable)
+                    path2 = [default_location dir_list(a).name executable{b}];
+                    if exist(path2, 'file') == 2
+                        path_ = path2;
+                        ver_num = ver_num2;
+                    end
+                end
+            end
+        end
+        if check_store_gs_path(path_)
+            return
+        end
+    else
+        executable = {'/usr/bin/gs', '/usr/local/bin/gs'};
+        for a = 1:numel(executable)
+            path_ = executable{a};
+            if check_store_gs_path(path_)
+                return
+            end
+        end
     end
-    executable = {'\bin\gswin32c.exe', '\bin\gswin64c.exe'};
-    ver_num = 0;
-    % If there are multiple versions, use the newest
-    for a = 1:numel(dir_list)
-        ver_num2 = sscanf(dir_list(a).name, 'gs%g');
-        if ~isempty(ver_num2) && ver_num2 > ver_num
-            for b = 1:numel(executable)
-                path2 = [default_location dir_list(a).name executable{b}];
-                if exist(path2, 'file') == 2
-                    path_ = path2;
-                    ver_num = ver_num2;
+    % Ask the user to enter the path
+    while true
+        if strncmp(computer, 'MAC', 3) % Is a Mac
+            % Give separate warning as the uigetdir dialogue box doesn't have a
+            % title
+            uiwait(warndlg('Ghostscript not found. Please locate the program.'))
+        end
+        base = uigetdir('/', 'Ghostcript not found. Please locate the program.');
+        if isequal(base, 0)
+            % User hit cancel or closed window
+            break;
+        end
+        base = [base filesep]; %#ok<AGROW>
+        bin_dir = {'', ['bin' filesep], ['lib' filesep]};
+        for a = 1:numel(bin_dir)
+            for b = 1:numel(bin)
+                path_ = [base bin_dir{a} bin{b}];
+                if exist(path_, 'file') == 2
+                    if check_store_gs_path(path_)
+                        return
+                    end
                 end
             end
         end
     end
-    if check_store_gs_path(path_)
-        return
+    if ismac
+        error('Ghostscript not found. Have you installed it (http://pages.uoregon.edu/koch)?');
+    else
+        error('Ghostscript not found. Have you installed it from www.ghostscript.com?');
     end
-else
-    executable = {'/usr/bin/gs', '/usr/local/bin/gs'};
-    for a = 1:numel(executable)
-        path_ = executable{a};
-        if check_store_gs_path(path_)
-            return
-        end
-    end
-end
-% Ask the user to enter the path
-while 1
-    if strncmp(computer, 'MAC', 3) % Is a Mac
-        % Give separate warning as the uigetdir dialogue box doesn't have a
-        % title
-        uiwait(warndlg('Ghostscript not found. Please locate the program.'))
-    end
-    base = uigetdir('/', 'Ghostcript not found. Please locate the program.');
-    if isequal(base, 0)
-        % User hit cancel or closed window
-        break;
-    end
-    base = [base filesep];
-    bin_dir = {'', ['bin' filesep], ['lib' filesep]};
-    for a = 1:numel(bin_dir)
-        for b = 1:numel(bin)
-            path_ = [base bin_dir{a} bin{b}];
-            if exist(path_, 'file') == 2
-                if check_store_gs_path(path_)
-                    return
-                end
-            end
-        end
-    end
-end
-error('Ghostscript not found. Have you installed it from www.ghostscript.com?');
 end
 
 function good = check_store_gs_path(path_)
-% Check the path is valid
-good = check_gs_path(path_);
-if ~good
-    return
-end
-% Update the current default path to the path found
-if ~user_string('ghostscript', path_)
-    warning('Path to ghostscript installation could not be saved. Enter it manually in %s.', fullfile(fileparts(which('user_string.m')), '.ignore', 'ghostscript.txt'));
-    return
-end
+    % Check the path is valid
+    good = check_gs_path(path_);
+    if ~good
+        return
+    end
+    % Update the current default path to the path found
+    if ~user_string('ghostscript', path_)
+        filename = fullfile(fileparts(which('user_string.m')), '.ignore', 'ghostscript.txt');
+        warning('Path to ghostscript installation could not be saved in %s (perhaps a permissions issue). You can manually create this file and set its contents to %s, to improve performance in future invocations (this warning is safe to ignore).', filename, path_);
+        return
+    end
 end
 
 function good = check_gs_path(path_)
-% Check the path is valid
-shell_cmd = '';
-if ismac
-    shell_cmd = 'export DYLD_LIBRARY_PATH=""; ';  % Avoids an error on Mac with GS 9.07
+    persistent isOk
+    if isempty(path_)
+        isOk = false;
+    elseif ~isequal(isOk,true)
+        % Check whether the path is valid
+        [status, message] = system([gs_command(path_) '-h']); %#ok<ASGLU>
+        isOk = status == 0;
+    end
+    good = isOk;
 end
-[good, message] = system(sprintf('%s"%s" -h', shell_cmd, path_));
-good = good == 0;
+
+function cmd = gs_command(path_)
+    % Initialize any required system calls before calling ghostscript
+    % TODO: in Unix/Mac, find a way to determine whether to use "export" (bash) or "setenv" (csh/tcsh)
+    shell_cmd = '';
+    if isunix
+        shell_cmd = 'export LD_LIBRARY_PATH=""; '; % Avoids an error on Linux with GS 9.07
+    end
+    if ismac
+        shell_cmd = 'export DYLD_LIBRARY_PATH=""; ';  % Avoids an error on Mac with GS 9.07
+    end
+    % Construct the command string
+    cmd = sprintf('%s"%s" ', shell_cmd, path_);
 end
Index: issm/trunk/externalpackages/export_fig/isolate_axes.m
===================================================================
--- issm/trunk/externalpackages/export_fig/isolate_axes.m	(revision 19105)
+++ issm/trunk/externalpackages/export_fig/isolate_axes.m	(revision 21341)
@@ -1,2 +1,3 @@
+function fh = isolate_axes(ah, vis)
 %ISOLATE_AXES Isolate the specified axes in a figure on their own
 %
@@ -22,98 +23,108 @@
 
 % Thank you to Rosella Blatt for reporting a bug to do with axes in GUIs
-% 16/3/2012 Moved copyfig to its own function. Thanks to Bob Fratantonio
-% for pointing out that the function is also used in export_fig.m.
-% 12/12/12 - Add support for isolating uipanels. Thanks to michael for
-% suggesting it.
-% 08/10/13 - Bug fix to allchildren suggested by Will Grant (many thanks!).
-% 05/12/13 - Bug fix to axes having different units. Thanks to Remington
-% Reid for reporting the issue.
+% 16/03/12: Moved copyfig to its own function. Thanks to Bob Fratantonio
+%           for pointing out that the function is also used in export_fig.m
+% 12/12/12: Add support for isolating uipanels. Thanks to michael for suggesting it
+% 08/10/13: Bug fix to allchildren suggested by Will Grant (many thanks!)
+% 05/12/13: Bug fix to axes having different units. Thanks to Remington Reid for reporting
+% 21/04/15: Bug fix for exporting uipanels with legend/colorbar on HG1 (reported by Alvaro
+%           on FEX page as a comment on 24-Apr-2014); standardized indentation & help section
+% 22/04/15: Bug fix: legends and colorbars were not exported when exporting axes handle in HG2
 
-function fh = isolate_axes(ah, vis)
-% Make sure we have an array of handles
-if ~all(ishandle(ah))
-    error('ah must be an array of handles');
-end
-% Check that the handles are all for axes or uipanels, and are all in the same figure
-fh = ancestor(ah(1), 'figure');
-nAx = numel(ah);
-for a = 1:nAx
-    if ~ismember(get(ah(a), 'Type'), {'axes', 'uipanel'})
-        error('All handles must be axes or uipanel handles.');
+    % Make sure we have an array of handles
+    if ~all(ishandle(ah))
+        error('ah must be an array of handles');
     end
-    if ~isequal(ancestor(ah(a), 'figure'), fh)
-        error('Axes must all come from the same figure.');
+    % Check that the handles are all for axes or uipanels, and are all in the same figure
+    fh = ancestor(ah(1), 'figure');
+    nAx = numel(ah);
+    for a = 1:nAx
+        if ~ismember(get(ah(a), 'Type'), {'axes', 'uipanel'})
+            error('All handles must be axes or uipanel handles.');
+        end
+        if ~isequal(ancestor(ah(a), 'figure'), fh)
+            error('Axes must all come from the same figure.');
+        end
     end
-end
-% Tag the objects so we can find them in the copy
-old_tag = get(ah, 'Tag');
-if nAx == 1
-    old_tag = {old_tag};
-end
-set(ah, 'Tag', 'ObjectToCopy');
-% Create a new figure exactly the same as the old one
-fh = copyfig(fh); %copyobj(fh, 0);
-if nargin < 2 || ~vis
-    set(fh, 'Visible', 'off');
-end
-% Reset the object tags
-for a = 1:nAx
-    set(ah(a), 'Tag', old_tag{a});
-end
-% Find the objects to save
-ah = findall(fh, 'Tag', 'ObjectToCopy');
-if numel(ah) ~= nAx
-    close(fh);
-    error('Incorrect number of objects found.');
-end
-% Set the axes tags to what they should be
-for a = 1:nAx
-    set(ah(a), 'Tag', old_tag{a});
-end
-% Keep any legends and colorbars which overlap the subplots
-lh = findall(fh, 'Type', 'axes', '-and', {'Tag', 'legend', '-or', 'Tag', 'Colorbar'});
-nLeg = numel(lh);
-if nLeg > 0
-    set([ah(:); lh(:)], 'Units', 'normalized');
-    ax_pos = get(ah, 'OuterPosition');
-    if nAx > 1
-        ax_pos = cell2mat(ax_pos(:));
+    % Tag the objects so we can find them in the copy
+    old_tag = get(ah, 'Tag');
+    if nAx == 1
+        old_tag = {old_tag};
     end
-    ax_pos(:,3:4) = ax_pos(:,3:4) + ax_pos(:,1:2);
-    leg_pos = get(lh, 'OuterPosition');
-    if nLeg > 1;
-        leg_pos = cell2mat(leg_pos);
+    set(ah, 'Tag', 'ObjectToCopy');
+    % Create a new figure exactly the same as the old one
+    fh = copyfig(fh); %copyobj(fh, 0);
+    if nargin < 2 || ~vis
+        set(fh, 'Visible', 'off');
     end
-    leg_pos(:,3:4) = leg_pos(:,3:4) + leg_pos(:,1:2);
-    ax_pos = shiftdim(ax_pos, -1);
-    % Overlap test
-    M = bsxfun(@lt, leg_pos(:,1), ax_pos(:,:,3)) & ...
-        bsxfun(@lt, leg_pos(:,2), ax_pos(:,:,4)) & ...
-        bsxfun(@gt, leg_pos(:,3), ax_pos(:,:,1)) & ...
-        bsxfun(@gt, leg_pos(:,4), ax_pos(:,:,2));
-    ah = [ah; lh(any(M, 2))];
-end
-% Get all the objects in the figure
-axs = findall(fh);
-% Delete everything except for the input objects and associated items
-delete(axs(~ismember(axs, [ah; allchildren(ah); allancestors(ah)])));
+    % Reset the object tags
+    for a = 1:nAx
+        set(ah(a), 'Tag', old_tag{a});
+    end
+    % Find the objects to save
+    ah = findall(fh, 'Tag', 'ObjectToCopy');
+    if numel(ah) ~= nAx
+        close(fh);
+        error('Incorrect number of objects found.');
+    end
+    % Set the axes tags to what they should be
+    for a = 1:nAx
+        set(ah(a), 'Tag', old_tag{a});
+    end
+    % Keep any legends and colorbars which overlap the subplots
+    % Note: in HG1 these are axes objects; in HG2 they are separate objects, therefore we
+    %       don't test for the type, only the tag (hopefully nobody but Matlab uses them!)
+    lh = findall(fh, 'Tag', 'legend', '-or', 'Tag', 'Colorbar');
+    nLeg = numel(lh);
+    if nLeg > 0
+        set([ah(:); lh(:)], 'Units', 'normalized');
+        try
+            ax_pos = get(ah, 'OuterPosition'); % axes and figures have the OuterPosition property
+        catch
+            ax_pos = get(ah, 'Position'); % uipanels only have Position, not OuterPosition
+        end
+        if nAx > 1
+            ax_pos = cell2mat(ax_pos(:));
+        end
+        ax_pos(:,3:4) = ax_pos(:,3:4) + ax_pos(:,1:2);
+        try
+            leg_pos = get(lh, 'OuterPosition');
+        catch
+            leg_pos = get(lh, 'Position');  % No OuterPosition in HG2, only in HG1
+        end
+        if nLeg > 1;
+            leg_pos = cell2mat(leg_pos);
+        end
+        leg_pos(:,3:4) = leg_pos(:,3:4) + leg_pos(:,1:2);
+        ax_pos = shiftdim(ax_pos, -1);
+        % Overlap test
+        M = bsxfun(@lt, leg_pos(:,1), ax_pos(:,:,3)) & ...
+            bsxfun(@lt, leg_pos(:,2), ax_pos(:,:,4)) & ...
+            bsxfun(@gt, leg_pos(:,3), ax_pos(:,:,1)) & ...
+            bsxfun(@gt, leg_pos(:,4), ax_pos(:,:,2));
+        ah = [ah; lh(any(M, 2))];
+    end
+    % Get all the objects in the figure
+    axs = findall(fh);
+    % Delete everything except for the input objects and associated items
+    delete(axs(~ismember(axs, [ah; allchildren(ah); allancestors(ah)])));
 end
 
 function ah = allchildren(ah)
-ah = findall(ah);
-if iscell(ah)
-    ah = cell2mat(ah);
-end
-ah = ah(:);
+    ah = findall(ah);
+    if iscell(ah)
+        ah = cell2mat(ah);
+    end
+    ah = ah(:);
 end
 
 function ph = allancestors(ah)
-ph = [];
-for a = 1:numel(ah)
-    h = get(ah(a), 'parent');
-    while h ~= 0
-        ph = [ph; h];
-        h = get(h, 'parent');
+    ph = [];
+    for a = 1:numel(ah)
+        h = get(ah(a), 'parent');
+        while h ~= 0
+            ph = [ph; h];
+            h = get(h, 'parent');
+        end
     end
 end
-end
Index: issm/trunk/externalpackages/export_fig/pdftops.m
===================================================================
--- issm/trunk/externalpackages/export_fig/pdftops.m	(revision 19105)
+++ issm/trunk/externalpackages/export_fig/pdftops.m	(revision 21341)
@@ -16,5 +16,5 @@
 %
 % IN:
-%   cmd - Command string to be passed into pdftops.
+%   cmd - Command string to be passed into pdftops (e.g. '-help').
 %
 % OUT:
@@ -24,86 +24,127 @@
 % Copyright: Oliver Woodford, 2009-2010
 
-% Thanks to Jonas Dorn for the fix for the title of the uigetdir window on
-% Mac OS.
-% Thanks to Christoph Hertel for pointing out a bug in check_xpdf_path
-% under linux.
+% Thanks to Jonas Dorn for the fix for the title of the uigetdir window on Mac OS.
+% Thanks to Christoph Hertel for pointing out a bug in check_xpdf_path under linux.
 % 23/01/2014 - Add full path to pdftops.txt in warning.
+% 27/05/2015 - Fixed alert in case of missing pdftops; fixed code indentation
+% 02/05/2016 - Added possible error explanation suggested by Michael Pacer (issue #137)
+% 02/05/2016 - Search additional possible paths suggested by Jonas Stein (issue #147)
+% 03/05/2016 - Display the specific error message if pdftops fails for some reason (issue #148)
 
-% Call pdftops
-[varargout{1:nargout}] = system(sprintf('"%s" %s', xpdf_path, cmd));
+    % Call pdftops
+    [varargout{1:nargout}] = system(sprintf('"%s" %s', xpdf_path, cmd));
 end
 
 function path_ = xpdf_path
-% Return a valid path
-% Start with the currently set path
-path_ = user_string('pdftops');
-% Check the path works
-if check_xpdf_path(path_)
-    return
-end
-% Check whether the binary is on the path
-if ispc
-    bin = 'pdftops.exe';
-else
-    bin = 'pdftops';
-end
-if check_store_xpdf_path(bin)
-    path_ = bin;
-    return
-end
-% Search the obvious places
-if ispc
-    path_ = 'C:\Program Files\xpdf\pdftops.exe';
-else
-    path_ = '/usr/local/bin/pdftops';
-end
-if check_store_xpdf_path(path_)
-    return
-end
-% Ask the user to enter the path
-while 1
-    if strncmp(computer,'MAC',3) % Is a Mac
-        % Give separate warning as the uigetdir dialogue box doesn't have a
-        % title
-        uiwait(warndlg('Pdftops not found. Please locate the program, or install xpdf-tools from http://users.phg-online.de/tk/MOSXS/.'))
+    % Return a valid path
+    % Start with the currently set path
+    path_ = user_string('pdftops');
+    % Check the path works
+    if check_xpdf_path(path_)
+        return
     end
-    base = uigetdir('/', 'Pdftops not found. Please locate the program.');
-    if isequal(base, 0)
-        % User hit cancel or closed window
-        break;
+    % Check whether the binary is on the path
+    if ispc
+        bin = 'pdftops.exe';
+    else
+        bin = 'pdftops';
     end
-    base = [base filesep];
-    bin_dir = {'', ['bin' filesep], ['lib' filesep]};
-    for a = 1:numel(bin_dir)
-        path_ = [base bin_dir{a} bin];
-        if exist(path_, 'file') == 2
-            break;
+    if check_store_xpdf_path(bin)
+        path_ = bin;
+        return
+    end
+    % Search the obvious places
+    if ispc
+        paths = {'C:\Program Files\xpdf\pdftops.exe', 'C:\Program Files (x86)\xpdf\pdftops.exe'};
+    else
+        paths = {'/usr/bin/pdftops', '/usr/local/bin/pdftops'};
+    end
+    for a = 1:numel(paths)
+        path_ = paths{a};
+        if check_store_xpdf_path(path_)
+            return
         end
     end
-    if check_store_xpdf_path(path_)
+
+    % Ask the user to enter the path
+    errMsg1 = 'Pdftops not found. Please locate the program, or install xpdf-tools from ';
+    url1 = 'http://foolabs.com/xpdf';
+    fprintf(2, '%s\n', [errMsg1 '<a href="matlab:web(''-browser'',''' url1 ''');">' url1 '</a>']);
+    errMsg1 = [errMsg1 url1];
+    %if strncmp(computer,'MAC',3) % Is a Mac
+    %    % Give separate warning as the MacOS uigetdir dialogue box doesn't have a title
+    %    uiwait(warndlg(errMsg1))
+    %end
+
+    % Provide an alternative possible explanation as per issue #137
+    errMsg2 = 'If you have pdftops installed, perhaps Matlab is shaddowing it as described in ';
+    url2 = 'https://github.com/altmany/export_fig/issues/137';
+    fprintf(2, '%s\n', [errMsg2 '<a href="matlab:web(''-browser'',''' url2 ''');">issue #137</a>']);
+    errMsg2 = [errMsg2 url1];
+
+    state = 0;
+    while 1
+        if state
+            option1 = 'Install pdftops';
+        else
+            option1 = 'Issue #137';
+        end
+        answer = questdlg({errMsg1,'',errMsg2},'Pdftops error',option1,'Locate pdftops','Cancel','Cancel');
+        drawnow;  % prevent a Matlab hang: http://undocumentedmatlab.com/blog/solving-a-matlab-hang-problem
+        switch answer
+            case 'Install pdftops'
+                web('-browser',url1);
+            case 'Issue #137'
+                web('-browser',url2);
+                state = 1;
+            case 'Locate pdftops'
+                base = uigetdir('/', errMsg1);
+                if isequal(base, 0)
+                    % User hit cancel or closed window
+                    break
+                end
+                base = [base filesep]; %#ok<AGROW>
+                bin_dir = {'', ['bin' filesep], ['lib' filesep]};
+                for a = 1:numel(bin_dir)
+                    path_ = [base bin_dir{a} bin];
+                    if exist(path_, 'file') == 2
+                        break
+                    end
+                end
+                if check_store_xpdf_path(path_)
+                    return
+                end
+
+            otherwise  % User hit Cancel or closed window
+                break
+        end
+    end
+    error('pdftops executable not found.');
+end
+
+function good = check_store_xpdf_path(path_)
+    % Check the path is valid
+    good = check_xpdf_path(path_);
+    if ~good
+        return
+    end
+    % Update the current default path to the path found
+    if ~user_string('pdftops', path_)
+        warning('Path to pdftops executable could not be saved. Enter it manually in %s.', fullfile(fileparts(which('user_string.m')), '.ignore', 'pdftops.txt'));
         return
     end
 end
-error('pdftops executable not found.');
-end
-
-function good = check_store_xpdf_path(path_)
-% Check the path is valid
-good = check_xpdf_path(path_);
-if ~good
-    return
-end
-% Update the current default path to the path found
-if ~user_string('pdftops', path_)
-    warning('Path to pdftops executable could not be saved. Enter it manually in %s.', fullfile(fileparts(which('user_string.m')), '.ignore', 'pdftops.txt'));
-    return
-end
-end
 
 function good = check_xpdf_path(path_)
-% Check the path is valid
-[good, message] = system(sprintf('"%s" -h', path_));
-% system returns good = 1 even when the command runs
-% Look for something distinct in the help text
-good = ~isempty(strfind(message, 'PostScript'));
+    % Check the path is valid
+    [good, message] = system(sprintf('"%s" -h', path_)); %#ok<ASGLU>
+    % system returns good = 1 even when the command runs
+    % Look for something distinct in the help text
+    good = ~isempty(strfind(message, 'PostScript'));
+
+    % Display the error message if the pdftops executable exists but fails for some reason
+    if ~good && exist(path_,'file')  % file exists but generates an error
+        fprintf('Error running %s:\n', path_);
+        fprintf(2,'%s\n\n',message);
+    end
 end
